% ex11x01.m
clear all
n = 8;
A = gallery('poisson',n);
A = gallery('wathen',n,n);
dim = size(A,1);
fprintf('Dimension der Matrix A ist %i x %i.\n',dim,dim);

reply = input('Mchten Sie sich die Besetzungsstruktur der Matrix ansehen? Y/N [N]: ','s');
if reply=='Y' || reply =='y' 
    figure(1);
    spy(A);
end
OK = 0;
while ~OK
  reply = input('Wieviele Iterationen mchten Sie ausfhren? [10-100]','s');
  [max_it,OK]=str2num(reply);
end
b = ones(dim,1);
x = rand(dim,1);
x_exakt = A\b;
error = zeros(max_it,1);
ew = eig(full(A));
gRichardson = 2/(min(ew)+max(ew));
for s = 1:max_it
  %x = x + gRichardson * (b-A*x);    % Richardson-Iteration 
                                     % rho = (ew_max - ew_min) / (ew_max + ew_min)
  %x = x + diag(diag(A))\(b-A*x);    % Jacobi-Iteration
  x = x +        triu(A)\(b-A*x);    % Gauss-Seidel-Iteration
  error(s) = norm(x-x_exakt);
end
c = error(1);
rho_u = 0.95; 
rho_o = 0.85;
semilogy(1:s,error,'k*',1:s,c*rho_o.^(0:s-1),'r',1:s,c*rho_u.^(0:s-1),'g'), 
xlabel('Anzahl der Iterationen')
ylabel('Fehler in der 2-Norm')
